<?php
// WizyTówka 4
if (!defined('WT')) exit();


// funkcje używane w panelu administracyjnym

// zapis otrzymanych z formularza ustawień w pliku konfiguracyjnym

function zapisKonfPOST ( ) {

	// wysokie zabezpieczenie ...wysokiego zabezpieczenia, aby nie można było go złamać przez formularz
	if ( isset($_POST['wysokieZabezpieczenie']) ) {
		unset($_POST['wysokieZabezpieczenie']);
		trigger_error( 'Nie udało ci się złamać wysokiego zabezpieczenia!', E_USER_WARNING );
		exit();
	}

	if ( isset($_POST['checkboksy']) ) {

		$checkboksy = explode(',',$_POST['checkboksy']);
		unset($_POST['checkboksy']);

		foreach ( $checkboksy as $checkbox ) {
			$wyzerowaneCheckboksy[$checkbox] = '0';
		}
		$_POST = array_replace( $wyzerowaneCheckboksy, $_POST );

	}

	zapisKonf( bezpiecznyHTML($_POST) );

}

// zapis strony

function zapisStronyZFormularza ( $tablicaZDanymi, $identyfikator, $szkic = false, $zawartoscZamiastUstawien = false ) {

	if ( isset($_POST['checkboksy']) ) {

		$checkboksy = explode(',',$_POST['checkboksy']);
		if ( isset($tablicaZDanymi['checkboksy']) )
			unset($tablicaZDanymi['checkboksy']);

		foreach ( $checkboksy as $checkbox ) {
			if ( strpos($checkbox,'[') !== false ) {
				$checkbox = explode( '[', $checkbox );
				$wyzerowaneCheckboksy[ $checkbox[0] ][ substr($checkbox[1],0,-1) ] = '0';
				// jeżeli tablica[element], musimy się trochę więcej narobić...
			}
			else
				$wyzerowaneCheckboksy[$checkbox] = '0';
		}

		$tablicaZDanymi = array_replace_recursive( $wyzerowaneCheckboksy, $tablicaZDanymi );

	}

	if ( !$zawartoscZamiastUstawien )
		$tablicaZDanymi = bezpiecznyHTML($tablicaZDanymi);

	zapisPlikuWTK(
		$tablicaZDanymi,
		(($szkic) ? 'szkice/' : 'strony/') . $identyfikator . (($zawartoscZamiastUstawien) ? '.wtz' : '.wtk'),
		false
	);

}

// lista zainstalowanych typów zawartości stron lub motywów (mają podobną strukturę)

function zainstalowaneTypyMotywy ( $element ) {

	if ( $element != 'typy' and $element != 'motywy' )
		return false;

	$wszystkieDane   = plikiFolderu( DANE   . '/' . $element, true );
	$wszystkieSystem = plikiFolderu( SYSTEM . '/' . $element, true );

	if ( !empty($wszystkieDane) ) {

		foreach ( $wszystkieDane as $klucz => $identyfikator ) {
			if ( !file_exists( DANE . '/' . $element . '/' . $identyfikator . '/' . $identyfikator . '.wtu' ) )
				unset( $wszystkieDane[ $klucz ] );
		}

		$wszystkie = array_unique( array_merge($wszystkieSystem,$wszystkieDane) );

	}
	else
		$wszystkie = $wszystkieSystem;

	if ( empty($wszystkie) )
		trigger_error( 'Nie są zainstalowane żadne typy/motywy.', E_USER_WARNING );

	return $wszystkie;

}

// komunikat nad panelem admina

function komunikat( $tresc = null ) {

	if ( empty($tresc) ) {
		$tablica = pamiecPodreczna( 'komunikat' );
		return $tablica['tresc'];
	}

	else {

		if ( $tresc == 1 )
			$tresc = 'dob.Zmiany zostały zapisane.';
		elseif ( $tresc == 2 )
			$tresc = 'zle.Wystąpił błąd.';

		$komunikat = array( 'tresc' => $tresc );
		pamiecPodreczna ( $komunikat, 'komunikat' );

	}

}

// "I belive I can fly"...

function przekierowanie ( $adres = null ) {

	header ( 'Location: ' . ((empty($adres)) ? '?id=strony' : $adres) );

	if ( substr($adres,0,16) != '?id=edycjaStrony' )
		exit();
		// na stronie 'edycjaStrony' typy zawartości strony mogą modyfikować tablice zawartości strony w trzecim etapie panelu admina (pierwszym od góry w kodzie), oczekując na ich nadpisanie po załadowaniu ostatniego etapu panelu admina (zmienna $wtWymuszenieZapisu), dlatego w tym miejscu nie wolno przerwać wykonywania kodu

}

// zaznaczanie checkboksów

function zaznaczCheckbox ( $ustawienie, $wartoscZaznaczajaca = true ) {

	if ( $ustawienie == $wartoscZaznaczajaca )
		echo 'checked';

}

// wyłączanie inputów, checkboksów...

function wylaczElement ( $ustawienie, $wartoscZaznaczajaca = true ) {

	if ( $ustawienie == $wartoscZaznaczajaca )
		echo 'disabled';

}

// elementy listy <select>, generowanie <option>..</option>

function generujListeWyboru ( $tablica, $wartoscZaznaczona = null ) {

	foreach ( $tablica as $klucz => $wartosc ) {

		echo '<option';

		if ( (!is_numeric($klucz) and $klucz == $wartoscZaznaczona) or (is_numeric($klucz) and $wartosc == $wartoscZaznaczona) )
			echo ' selected';

		if ( !is_numeric($klucz) )
			echo ' value="', $klucz, '"';

		echo '>', $wartosc, '</option>';

	}

}

// edytor WYSIWYG - CKEditor

function edytorWizualny( $tylkoDoOdczytu = false ) {

	if ( odczytKonf('sposobEdycjiTekstu') == 'edytorWizualny' and odczytKonf('edytorWizualny') ) {

		if ( odczytKonf('edytorWizualnyStylMotywu') )
			$odczytMotywu = odczytTypuMotywu( 'motywy', odczytKonf('motyw') );
?>
<script src="<?php echo (odczytKonf('edytorWizualnyWlasny')) ? DANE : SYSTEM.'/admin/pliki' ?>/ckeditor/ckeditor.js"></script>

<script>
	CKEDITOR.replace( 'edytorWizualny', {

		filebrowserBrowseUrl      : '<?php echo odczytKonf('panelAdminAdres') ?>?id=wyslanePliki',
		filebrowserImageBrowseUrl : '<?php echo odczytKonf('panelAdminAdres') ?>?id=wyslanePliki&tylkoGraficzne',
		filebrowserUploadUrl      : '<?php echo odczytKonf('panelAdminAdres') ?>?id=wyslijPliki',

		filebrowserWindowWidth  : '855',
		filebrowserWindowHeight : '600',

		<?php if ( !odczytKonf('edytorWizualnyWlasny') ) { ?>
		skin : '<?php echo (odczytKonf('kontrastowyPanelAdmin')) ? 'moono-dark' : 'moono' ?>',
		dialog_backgroundCoverColor : '<?php echo (odczytKonf('kontrastowyPanelAdmin')) ? '#000' : '#FFF' ?>',
		<?php } ?>

		removeButtons  : '<?php echo odczytKonf('edytorWizualnyUkrytePrzyciski') ?>',
		format_tags    : '<?php echo odczytKonf('edytorWizualnyFormatowanie') ?>',
		height         : '<?php echo odczytKonf('edytorWizualnyWysokosc') ?>',
		allowedContent : <?php echo (odczytKonf('edytorWizualnyOgraniczHTML')) ? 'false' : 'true' ?>,
		readOnly       : <?php echo ($tylkoDoOdczytu) ? 'true' : 'false' ?>,

		<?php if ( isset($odczytMotywu) and $odczytMotywu['informacje']['edytorWizualny'] ) { ?>
		contentsCss : "<?php echo odczytKonf('adres'), '/', (( $odczytMotywu['wlasny'] ) ?  DANE  :  SYSTEM), '/motywy/', odczytKonf('motyw'), '/edytor.css' ?>",
		<?php } ?>

		on: {
			instanceReady: function( ev ) {
				this.dataProcessor.writer.selfClosingEnd = '>';
				this.dataProcessor.writer.setRules( 'style', { breakBeforeClose: false } );
			}
		}

	} );
</script>
<?php
	}

}

// generowanie pliku sitemap.xml

function generujMapeWitryny() {

	if ( odczytKonf('mapaWitryny') == 'nieTworz' )
		return false;

	$stronyMapy = array();

	if ( odczytKonf('mapaWitryny') == 'tworzTylkoWybrane' ) {

		$stronyMapy = explode( ';', odczytKonf('mapaWitrynyStrony') );

		foreach ( $stronyMapy as $klucz => $identyfikatorStrony ) {
			if ( !odczytStrony($identyfikatorStrony) )
				unset( $stronyMapy[$klucz] );
		}

	}

	else {

		$stronyMapy = listaStron();

		if ( odczytKonf('mapaWitryny') == 'tworzWyjatki' ) {

			$stronyWykluczone = explode( ';', odczytKonf('mapaWitrynyStrony') );

			foreach( $stronyMapy as $klucz => $identyfikatorStrony ) {
				foreach ( $stronyWykluczone as $identyfikatorWykluczonej ) {
					if ( $identyfikatorStrony == $identyfikatorWykluczonej )
						unset( $stronyMapy[$klucz] );
				}
			}

		}

	}

	if ( empty($stronyMapy) or !is_writable('.') )
		return false;

	$z = ( odczytKonf('przyjazneAdresy') ) ? null : '?id=';

	$trescPliku = '<?xml version="1.0" encoding="UTF-8"?>' . "\n" . '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . "\n";

	foreach ( $stronyMapy as $identyfikator )
		$trescPliku .= '	<url>' . "\n" . '		<loc>' . odczytKonf('adres') . '/' . $z . $identyfikator . '</loc>' . "\n" . '		<changefreq>weekly</changefreq>' . "\n" . '		<priority>1.0</priority>' . "\n" . '	</url>' . "\n";

	$trescPliku .= '</urlset>';

	return file_put_contents( 'sitemap.xml', $trescPliku );

}

// aktualizowanie menu głównego i dodatkowego

function aktualizujMenuGlowneDodatkowe ( $zamianaZCzego = null, $zamianaNaCo = null ) {

	// jeżeli brak argumentów - aktualizujemy; jeśli jeden - dodajemy na końcu menu; jeśli dwa - zamieniamy

	$odczytElementow = odczytPlikuWTK('elementy.wtk');

	if ( $zamianaZCzego != '' ) {

		// dodanie nowej strony do menu głownego lub dodatkowego
		if ( $zamianaNaCo == '' )
			$odczytElementow['menu'][ (odczytKonf('menuAutomatycznie') == 2) ? 'menuDodatkowe' : 'menuGlowne' ][] = $zamianaZCzego;

		// zamiana identyfikatora elementu w menu na inny identyfikator lub kropkę (puste miejsce)
		else {
			foreach ( $odczytElementow['menu'] as $nazwaTegoMenu => $tablicaTegoMenu ) {
				foreach ( $tablicaTegoMenu as $klucz => $elementMenu ) {
					if ( $elementMenu == $zamianaZCzego )
						$odczytElementow['menu'][ $nazwaTegoMenu ][ $klucz ] = $zamianaNaCo;
				}
			}
		}

	}

	// aktualizacja pamięci podręcznej tytułów elementów menu
	$odczytElementow['tytulyStronMenu'] = array();
	foreach ( $odczytElementow['menu'] as $tablicaTegoMenu ) {
		foreach ( $tablicaTegoMenu as $identyfikatorStrony ) {
			if ( $identyfikatorStrony == '.' )
				continue;       // kropka tu pusty element menu
			$odczytStrony = odczytStrony($identyfikatorStrony);
			$odczytElementow['tytulyStronMenu'][ $identyfikatorStrony ] = $odczytStrony['tytulMenu'];
		}
	}

	zapisPlikuWTK( $odczytElementow, 'elementy.wtk' );

}

// usprawniony i rekurencyjny glob()

function plikiFolderu ( $lokalizacja, $tylkoFoldery = false, $rekurencyjnie = true ) {

	$plikiFolderu = glob( $lokalizacja . '/*', ($tylkoFoldery) ? GLOB_ONLYDIR : null );

	if ( empty($plikiFolderu) )
		return array();

	foreach ( $plikiFolderu as $klucz => $pelnaSciezka ) {

		$plikiFolderu[$klucz] = basename($pelnaSciezka);

		if ( $rekurencyjnie and !$tylkoFoldery and is_dir( $lokalizacja . '/' . $plikiFolderu[$klucz] ) ) {
			$plikiPodfolderu = plikiFolderu($pelnaSciezka);
			foreach ( $plikiPodfolderu as $nazwaPodfolder )
				$plikiFolderu[] = $plikiFolderu[$klucz] . '/' . $nazwaPodfolder;
			unset($plikiFolderu[$klucz]);
		}

	}

	return $plikiFolderu;

}

// htmlspecialchars(), ale rekurencyjnie dla tablic

function bezpiecznyHTML ( $x ) {

	if ( is_array($x) ) {
		foreach ( $x as $nazwa => $element )
			$x[$nazwa] = bezpiecznyHTML($element);
		return $x;
	}
	else
		return htmlspecialchars($x);

}