<?php
// WizyTówka 4
if (!defined('WT')) exit();


// podstawowe stałe, ustawienia, funkcje...

if ( ini_get( 'register_globals' ) or ini_get( 'magic_quotes_gpc' ) )
	die('System WizyTówka nie zostanie uruchomiony. Wyłącz opcje "register_globals" i "magic_quotes_gpc" w pliku php.ini.');
if ( !function_exists('mb_internal_encoding') )
	die('System WizyTówka nie zostanie uruchomiony. Zainstaluj funkcje multibajtowe.');

error_reporting( E_ALL );
include( 'funkcje/bledy.php' );
set_error_handler( 'wychwytywanieBledow' );

setlocale( LC_ALL, 'pl_PL', 'pl_PL.UTF-8', 'pl', 'Polish_Poland.28592' );
mb_internal_encoding('UTF-8');

define( 'WERSJA',      '4.23'       );
define( 'WERSJA_DATA', '2015-01-24' );   // ropoczęcie prac: 2013-07-13

include( 'funkcje/ciagi.php' );
include( 'funkcje/dane.php' );


// instalator

if ( !file_exists( DANE . '/wtk/konfiguracja.wtk' ) ) {
	include( SYSTEM . '/admin/strony/instalator.php' );
	exit();
}


// aktualizator

if ( odczytKonf('wersjaWT') < floatval(WERSJA) ) {
	include('aktualizator.php');
	exit();
}


// stałe adresu

if ( isset($_GET['id']) )
	define( 'ID', $_GET['id'] );
if ( isset($_GET['b']) )
	define( 'ID2', $_GET['b'] );


// ciąg dalszy zależny od celu naszej podróży...


if ( $start == 'strona' ) {

	// przekierowanie z /?a=strona do /strona jeśli jest taka potrzeba

	if ( defined('ID') and strpos($_SERVER['REQUEST_URI'],'?id=') !== false and odczytKonf('przyjazneAdresy') ) {
		header( 'Location: ' . odczytKonf('adres') . '/' . ID );
		exit();
	}

	// tryb przerwy technicznej

	if ( odczytKonf('przerwaTechniczna') and !zalogowany() ) {
		include('przerwa.php');
		exit();
	}

	include( 'funkcje/witryna.php' );

	// zdefiniowanie identyfikatora strony

	if ( defined('ID') )
		define( 'IDENTYFIKATOR', ID );
	else {
		if ( zalogowany() and isset($_GET['podgladSzkicu']) )
			define( 'IDENTYFIKATOR', str_rot13($_GET['podgladSzkicu']) );
		else
			define( 'IDENTYFIKATOR', odczytKonf('stronaGlowna') );
	}

	// wrzucenie do pamięci podręcznej wszystkich informacji o witrynie

	pamiecPodreczna( odczytStrony( IDENTYFIKATOR, isset($_GET['podgladSzkicu']), false ), 'odczytStrony'     );
	pamiecPodreczna( odczytStrony( IDENTYFIKATOR, isset($_GET['podgladSzkicu']), true  ), 'odczytZawartosci' );

	// wrzucenie do pamięci podręcznej ustawień typu i motywu

	$odczytStrony = pamiecPodreczna('odczytStrony');

	pamiecPodreczna( odczytTypuMotywu( 'typy',  $odczytStrony['typ'] ), 'odczytTypu'   );
	pamiecPodreczna( odczytTypuMotywu( 'motywy', odczytKonf('motyw') ), 'odczytMotywu' );

	// załadowanie fragmentu typu zawartości strony, jeśli deklaruje on taką potrzebę

	$odczytTypu = pamiecPodreczna('odczytTypu');

	if ( !$odczytTypu and $odczytStrony != false )
		trigger_error( 'Typ zawartości strony "' . $odczytStrony['typ'] . '" nie istnieje.', E_USER_WARNING );

	if ( $odczytTypu['informacje']['naglowkiHTTP'] ) {

		$odczytZawartosci = pamiecPodreczna('odczytZawartosci');

		// dla kodu typów zawartości stron:
		$wtZawartoscStrony  = &$odczytZawartosci;
		$wtUstawieniaStrony = &$odczytStrony;

		include( (($odczytTypu['wlasny']) ? DANE : SYSTEM) . '/typy/' . $odczytStrony['typ'] . '/http.php' );

	}

	// przygotowanie zmiennej potrzebnej do załadowania motywu

	$odczytMotywu = pamiecPodreczna('odczytMotywu');

	if ( $odczytMotywu['wlasny'] )
		$odczytMotywuWlasny = true;

	// wrzucenie do pamięci podręcznej kolejnych częsci ustawień witryny

	pamiecPodreczna( odczytPlikuWTK('elementy.wtk'),   'odczytElementow' );
	pamiecPodreczna( odczytPlikuWTK('statystyki.wtk'), 'odczytStatystyk' );

	// uproszczone statystyki odwiedzin

	if ( !zalogowany() and odczytKonf('statystyki') ) {

		if ( !isset($_COOKIE['WT_statystyki']) )
			setcookie( 'WT_statystyki', '2', mktime( 0, 0, 0, date('m'), date('d')+1, date('Y') ) );

		if ( isset($_COOKIE['WT_statystyki']) and $_COOKIE['WT_statystyki'] == '2'
			and strpos( strtolower($_SERVER['HTTP_USER_AGENT']), 'bot' ) === false ) {

			$odczytStatystyk = pamiecPodreczna('odczytStatystyk');

			// wyczyszczenie licznika dnia dzisiejszego po jego zakończeniu
			if ( time() > $odczytStatystyk['dzisiaj']['waznoscDzisiaj'] ) {
				$odczytStatystyk['dzisiaj']['odwiedzajacych'] = 0;
				$odczytStatystyk['dzisiaj']['waznoscDzisiaj'] = mktime( 0, 0, 0, date('m'), date('d')+1, date('Y') );
				zapisPlikuWTK( $odczytStatystyk, 'statystyki.wtk' );
			}

			++$odczytStatystyk['suma'];
			++$odczytStatystyk['dzisiaj']['odwiedzajacych'];
			$odczytStatystyk['dzisiaj']['dataOstatniego'] = time();

			if ( isset( $odczytStatystyk['archiwum'][ date('Y') ][ date('n') ] ) )
				++$odczytStatystyk['archiwum'][ date('Y') ][ date('n') ];
			else
				$odczytStatystyk['archiwum'][ date('Y') ][ date('n') ] = 1;

			zapisPlikuWTK( $odczytStatystyk, 'statystyki.wtk' );
			setcookie( 'WT_statystyki', '1', mktime( 0, 0, 0, date('m'), date('d')+1, date('Y') ) );

		}

	}

	// usunięcie z pamięci wszystkich roboczych zmiennych użytych w niniejszym pliku

	unset( $odczytStrony, $odczytTypu, $odczytMotywu, $odczytStatystyk, $odczytElementow );

	// załadowanie pliku motywu i, z nim, treści strony            ...nareszczcie!

	if ( !include ( ((isset($odczytMotywuWlasny)) ? DANE : SYSTEM) . '/motywy/' . odczytKonf('motyw') . '/witryna.php' ) ) {
		define( 'BLEDY_KRYTYCZNE', 1 );
		trigger_error( 'Nie można wyświetlić witryny, motyw "' . odczytKonf('motyw') . '" nie istnieje.', E_USER_WARNING );
	}

}


elseif ( $start == 'admin' ) {

	include( 'funkcje/admin.php' );

	// wylogowywanie

	if ( isset($_GET['wyloguj']) ) {

		zapisKonf( array( 'identyfikatorLogowania' => '' ) );
		setcookie( 'WT_administracja', '', 0 );

		przekierowanie('?wylogowano');

	}

	// panel administracyjny

	if ( zalogowany() ) {

		if ( defined('ID') and file_exists( SYSTEM . '/admin/strony/' . ID . '.php' ) )
			include( SYSTEM . '/admin/strony/' . ID . '.php' );
		else
			przekierowanie();

	}

	// logowanie

	else {
		header('HTTP/1.1 418 I\'m a teapot');
		include( SYSTEM . '/admin/strony/logowanie.php' );
	}

}