<?php
// WizyTówka 4
if (!defined('WT')) exit();

$wyszukiwaneWyrazenie = (isset($_POST['wyszukiwaneWyrazenie'])) ? $_POST['wyszukiwaneWyrazenie'] : '';

if ( !empty($wyszukiwaneWyrazenie) ) {

	// funkcja umożliwiająca rekurencyjne przeszukiwanie tablic i ciągów znaków

	function wyszukujRekurencyjnie ( $przeszukiwanyElement, $szukaneWyrazenie ) {
		if ( is_array($przeszukiwanyElement) ) {
			foreach ( $przeszukiwanyElement as $pojElement ) {
				if ( wyszukujRekurencyjnie( $pojElement, $szukaneWyrazenie ) )
					return true;
			}
		}
		elseif ( is_string($przeszukiwanyElement) and !empty($przeszukiwanyElement) ) {
			if ( mb_stripos( bezPolskichZnakow($przeszukiwanyElement), $szukaneWyrazenie ) !== false )
				return true;
		}
	}

	// funkcja usuwająca polskie znaki z ciągu znaków

	function bezPolskichZnakow ( $ciag ) {
		return zastepowanie(
			$ciag,
			array( 'ą' => 'a', 'ć' => 'c', 'ę' => 'e', 'ł' => 'l', 'ń' => 'n', 'ś' => 's', 'ó' => 'o', 'ż' => 'z', 'ź' => 'z', 'Ą' => 'A', 'Ć' => 'C', 'Ę' => 'E', 'Ł' => 'L', 'Ń' => 'N', 'Ś' => 'S', 'Ó' => 'O', 'Ż' => 'Z', 'Ź' => 'Z' )
		);
	}

	// utworzenie indeksu wyszukiwania z zawartością wszystkich stron witryny

	$indeksWyszukiwania = array();
	$stronyWykluczone   = explode( ';', $wtUstawieniaStrony['stronyWykluczone'] );
	$stronyWykluczone[] = IDENTYFIKATOR;   // żeby wyszukiwarka nie wyszukiwała samej siebie

	foreach ( listaStron() as $identyfikatorStrony ) {

		if ( in_array( $identyfikatorStrony, $stronyWykluczone ) )
			break;

		$odczytStrony2     = odczytStrony( $identyfikatorStrony, false, false );
		$odczytZawartosci2 = odczytStrony( $identyfikatorStrony, false, true  );
			// dwójka w nazwach zmienych pozwala uniknąć konfilktu z oryginalnymi zmiennymi WizyTówki

		$indeksWyszukiwania[ $identyfikatorStrony ]          = $odczytZawartosci2;
		$indeksWyszukiwania[ $identyfikatorStrony ]['tytul'] = $odczytStrony2['tytul'];

		if ( $wtUstawieniaStrony['informacjeWyszukiwarek'] ) {
			$indeksWyszukiwania[ $identyfikatorStrony ]['wyszukiwarkiOpis']          = $odczytStrony2['wyszukiwarkiOpis'];
			$indeksWyszukiwania[ $identyfikatorStrony ]['wyszukiwarkiSlowaKluczowe'] = $odczytStrony2['wyszukiwarkiSlowaKluczowe'];
		}

	}

	// wyniki wyszukiwania

	$wynikiWyszukiwania = array();
	$szukaneWyrazenia   = ($wtUstawieniaStrony['kazdeSlowoOsobno']) ? explode( ' ', bezPolskichZnakow($wyszukiwaneWyrazenie) ) : array(bezPolskichZnakow($wyszukiwaneWyrazenie));
		// szukane wyrażenie zostanie rozdzielone na poszczególne słowa, jeśli wskazano

	foreach ( $szukaneWyrazenia as $czescWyszukiwanegoWyrazenia ) {

		if ( $wtUstawieniaStrony['blokujKilkuliterowe'] and mb_strlen($czescWyszukiwanegoWyrazenia) < 3 )
			break;
			// blokada wyszukiwania spójników, np. "a", "od", "w", "na"

		foreach ( $indeksWyszukiwania as $identyfikatorStrony => $zawartosc ) {
			if ( wyszukujRekurencyjnie( $zawartosc, $czescWyszukiwanegoWyrazenia ) ) {
				$wynikiWyszukiwania[ $identyfikatorStrony ] = array(
					'tytul'   => $zawartosc['tytul'],
					'licznik' => isset($wynikiWyszukiwania[$identyfikatorStrony]['licznik']) ? ++$wynikiWyszukiwania[$identyfikatorStrony]['licznik'] : 0
				);
			}
		}

	}

	$wynikiWyszukiwania = sortowanie( $wynikiWyszukiwania, 'licznik', true );
		// strony, w których pojawia się kilka szukanych słów, znajdą się wyżej w wynikach

	if ( empty($wynikiWyszukiwania) ) {
	?>
<p class="wtKomunikat"><?php echo $wtUstawieniaStrony['komunikatBrakuWynikow'] ?></p>
	<?php
	}

}
?>

<form method="post" class="wtWyszukiwarka">
<dl>
<dt><label for="poleWyszukiwania">Wyszukiwane wyrażenie:</label></dt>
<dd><input type="text" name="wyszukiwaneWyrazenie" id="poleWyszukiwania" autofocus value="<?php echo $wyszukiwaneWyrazenie ?>"></dd>
</dl>
<p><input type="submit" value="<?php echo $wtUstawieniaStrony['przyciskWyszukiwania'] ?>"></p>
</form>

<script>
	document.querySelector('form').onsubmit = function() {
		if ( document.getElementById('poleWyszukiwania').value == '<?php echo $wyszukiwaneWyrazenie ?>' ||  document.getElementById('poleWyszukiwania').value == '' )
			return false;
	}
</script>

<?php

if ( !empty($wynikiWyszukiwania) ) {

	echo '<ul class="wtWyszukiwarka_wyniki">', "\n";

	foreach( $wynikiWyszukiwania as $identyfikatorStrony => $tablica )
		echo '<li><a href="', wtOdnosnik($identyfikatorStrony), '">', $tablica['tytul'] ,'</a></li>', "\n";

	echo '</ul>', "\n";

}

elseif ( $wtUstawieniaStrony['pokazTresc'] )
	echo tekst( $wtZawartoscStrony['tresc'], true );